import javax.microedition.midlet.MIDlet;
import javax.microedition.lcdui.*;
import java.io.*;
import javax.microedition.io.*;
import java.util.*;

public class Temporizador extends MIDlet implements Runnable, CommandListener {

    private Form formData;
    private DateField data;

	private Command cmdSair, cmdNovaExecuo;

    public Temporizador() {
     	cmdSair = new Command("Sair", Command.EXIT, 1);
		cmdNovaExecuo = new Command("Definir", Command.SCREEN, 1);

		formData = new Form("Temporizador");
      	data = new DateField("Prxima execuo", DateField.DATE_TIME);
      	data.setDate(new Date());

      	formData.append(data);
      	formData.addCommand(cmdSair);
      	formData.addCommand(cmdNovaExecuo);
      	formData.setCommandListener(this);
    }

    public void startApp() {
      	Display.getDisplay(this).setCurrent(formData);
    }

	public void destroyApp(boolean unconditional) {
	}

	public void pauseApp() {
	}

	public void commandAction(Command c, Displayable d) {
		if (c == cmdSair) {
			destroyApp(true);
			notifyDestroyed();
		} else if(c == cmdNovaExecuo) {
			new Thread(this).start();
		}
	}

	public void run() {
		try {
			PushRegistry.registerAlarm("Temporizador", data.getDate().getTime());
		} catch (ClassNotFoundException cnfe) {
			System.err.println("Erro de registo: " +cnfe.getMessage());
		} catch (ConnectionNotFoundException cnfe) {
			System.err.println("Erro de registo: " +cnfe.getMessage());
		}
		System.out.println("Nova execuo definida.");
	}
}